Code

git-stash: do not remove a ref by hand.
[git.git] / git-stash.sh
1 #!/bin/sh
2 # Copyright (c) 2007, Nanako Shiraishi
4 USAGE='[ | list | show | apply | clear]'
6 SUBDIRECTORY_OK=Yes
7 . git-sh-setup
8 require_work_tree
9 cd_to_toplevel
11 TMP="$GIT_DIR/.git-stash.$$"
12 trap 'rm -f "$TMP-*"' 0
14 ref_stash=refs/stash
16 no_changes () {
17         git diff-index --quiet --cached HEAD &&
18         git diff-files --quiet
19 }
21 clear_stash () {
22         if current=$(git rev-parse --verify $ref_stash 2>/dev/null)
23         then
24                 git update-ref -d refs/stash $current
25         fi
26 }
28 save_stash () {
29         stash_msg="$1"
31         if no_changes
32         then
33                 echo >&2 'No local changes to save'
34                 exit 0
35         fi
36         test -f "$GIT_DIR/logs/$ref_stash" ||
37                 clear_stash || die "Cannot initialize stash"
39         # state of the base commit
40         if b_commit=$(git rev-parse --verify HEAD)
41         then
42                 head=$(git log --abbrev-commit --pretty=oneline -n 1 HEAD)
43         else
44                 die "You do not have the initial commit yet"
45         fi
47         if branch=$(git symbolic-ref -q HEAD)
48         then
49                 branch=${branch#refs/heads/}
50         else
51                 branch='(no branch)'
52         fi
53         msg=$(printf '%s: %s' "$branch" "$head")
55         # state of the index
56         i_tree=$(git write-tree) &&
57         i_commit=$(printf 'index on %s' "$msg" |
58                 git commit-tree $i_tree -p $b_commit) ||
59                 die "Cannot save the current index state"
61         # state of the working tree
62         w_tree=$( (
63                 rm -f "$TMP-index" &&
64                 cp -p ${GIT_INDEX_FILE-"$GIT_DIR/index"} "$TMP-index" &&
65                 GIT_INDEX_FILE="$TMP-index" &&
66                 export GIT_INDEX_FILE &&
67                 git read-tree -m $i_tree &&
68                 git add -u &&
69                 git write-tree &&
70                 rm -f "$TMP-index"
71         ) ) ||
72                 die "Cannot save the current worktree state"
74         # create the stash
75         if test -z "$stash_msg"
76         then
77                 stash_msg=$(printf 'WIP on %s' "$msg")
78         else
79                 stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
80         fi
81         w_commit=$(printf '%s\n' "$stash_msg" |
82                 git commit-tree $w_tree -p $b_commit -p $i_commit) ||
83                 die "Cannot record working tree state"
85         git update-ref -m "$stash_msg" $ref_stash $w_commit ||
86                 die "Cannot save the current status"
87         printf >&2 'Saved "%s"\n' "$stash_msg"
88 }
90 have_stash () {
91         git rev-parse --verify $ref_stash >/dev/null 2>&1
92 }
94 list_stash () {
95         have_stash || return 0
96         git log --pretty=oneline -g "$@" $ref_stash |
97         sed -n -e 's/^[.0-9a-f]* refs\///p'
98 }
100 show_stash () {
101         flags=$(git rev-parse --no-revs --flags "$@")
102         if test -z "$flags"
103         then
104                 flags=--stat
105         fi
106         s=$(git rev-parse --revs-only --no-flags --default $ref_stash "$@")
108         w_commit=$(git rev-parse --verify "$s") &&
109         b_commit=$(git rev-parse --verify "$s^") &&
110         git diff $flags $b_commit $w_commit
113 apply_stash () {
114         git diff-files --quiet ||
115                 die 'Cannot restore on top of a dirty state'
117         unstash_index=
118         case "$1" in
119         --index)
120                 unstash_index=t
121                 shift
122         esac
124         # current index state
125         c_tree=$(git write-tree) ||
126                 die 'Cannot apply a stash in the middle of a merge'
128         s=$(git rev-parse --revs-only --no-flags --default $ref_stash "$@") &&
129         w_tree=$(git rev-parse --verify "$s:") &&
130         b_tree=$(git rev-parse --verify "$s^:") ||
131                 die "$*: no valid stashed state found"
133         test -z "$unstash_index" || {
134                 git diff --binary $s^2^..$s^2 | git apply --cached
135                 test $? -ne 0 &&
136                         die 'Conflicts in index. Try without --index.'
137                 unstashed_index_tree=$(git-write-tree) ||
138                         die 'Could not save index tree'
139                 git reset
140         }
142         eval "
143                 GITHEAD_$w_tree='Stashed changes' &&
144                 GITHEAD_$c_tree='Updated upstream' &&
145                 GITHEAD_$b_tree='Version stash was based on' &&
146                 export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
147         "
149         if git-merge-recursive $b_tree -- $c_tree $w_tree
150         then
151                 # No conflict
152                 a="$TMP-added" &&
153                 git diff --cached --name-only --diff-filter=A $c_tree >"$a" &&
154                 git read-tree --reset $c_tree &&
155                 git update-index --add --stdin <"$a" ||
156                         die "Cannot unstage modified files"
157                 git-status
158                 rm -f "$a"
159                 test -z "$unstash_index" || git read-tree $unstashed_index_tree
160         else
161                 # Merge conflict; keep the exit status from merge-recursive
162                 status=$?
163                 test -z "$unstash_index" || echo 'Index was not unstashed.' >&2
164                 exit $status
165         fi
168 # Main command set
169 case "$1" in
170 list)
171         shift
172         if test $# = 0
173         then
174                 set x -n 10
175                 shift
176         fi
177         list_stash "$@"
178         ;;
179 show)
180         shift
181         show_stash "$@"
182         ;;
183 apply)
184         shift
185         apply_stash "$@"
186         ;;
187 clear)
188         clear_stash
189         ;;
190 help | usage)
191         usage
192         ;;
193 *)
194         if test $# -gt 0 && test "$1" = save
195         then
196                 shift
197         fi
198         save_stash "$*" && git-reset --hard
199         ;;
200 esac